#ifndef _UNINSTALL_H_
#define _UNINSTALL_H_
#include <string>
#include <vector>
#include <map>
using namespace std;

#include <stdio.h>
#include <fstream.h>

#include "stringArray.h"

static string uninstall_ALL = "all";

typedef class unInstallCommand
{ public:
		string			command;
		stringArray	parameters;

    unInstallCommand() { };
    unInstallCommand(string commandname) { this->command = commandname; };
    unInstallCommand(string commandname, stringArray params)
    { this->command = commandname;
    	this->parameters = params;
    };
    void addParameter(string parameter) { this->parameters.add(parameter); };
    string commandName() { return this->command; };
    stringArray &parameterList() { return this->parameters; };
} unInstallCommand;

typedef vector<unInstallCommand> unInstallCommandList;

typedef map<string, unInstallCommandList, less<string> > unInstallCommandMap;

class installManager
{	private:
		fstream 							logfile;
    string								logfileName;
    string								currentModule;
    unInstallCommandMap 	modules;

    bool writeString(string str);
    bool writeString(char *string);
    bool writeSeparator();
    string readString();
    bool writeCommand(unInstallCommand &command);
    string readCommand(stringArray &params);
	public:
  	installManager() { };
    bool openLog(string filename, bool write);
    bool closeLog();
    bool reopenLog();
    void setModule(string moduleName);
    bool storeCommand(unInstallCommand &command);
    string popCommand(stringArray &params);
    bool isEmpty();
    ~installManager();
};

class installAgent
{	protected:
    installManager *manager;
	public:
  	installAgent(installManager &useManager) { this->manager = &useManager; };
    virtual bool undoAction(string actionName, stringArray &params) { return false; };
//    bool undo(string actionName);
};

#endif
